/*
   display.h
   Functions for the four character display

   by Steven L. Barnicki - 2/7/98
*/

#include <display.h>


void showstring(char* sin)
{
  byte* s=sin;
  byte j;
  byte pos=4;
  byte oldddrc;

  /* save old ddrc */
  oldddrc=ddrc;
  /* set port c direction out */
  ddrc = (byte) 0xFF;
  /* invert sense of STRB */
  j=pioc;
  j=j&0xfe; /* reset bit 0 to 0 */
  pioc=j;

  while( *s != '\0' )
  {
    if (pos==0)
      {
      pos=4;
      s-=3;
      wait(250);
      }
    else  /* ok to print */
      {
      portcl=pos-1;
      pos--;
      portb=(*s);
      s++;
      }
  }
  /* restore original ddrc */
  ddrc=oldddrc;
} /* showstring() */

void showchar(int pos, char ch)
{
  byte npos;
  byte j;

  /* set port c direction out */
  ddrc = (byte) 0xFF;
  /* invert sense of STRB */
  j=pioc;
  j=j&0xfe; /* reset bit 0 to 0 */
  pioc=j;
  /* the position     maps       */
  /* on display      in function */
  /*    3210           1234      */
  npos=pos-1;
  npos=~npos;
  npos=npos&0x03; /* only keep the 2 LSB */
  portcl=npos;
  portb=ch;
}  /* showchar() */

